unit DemoUnit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  TMKeyboardStatusBar,
  StdCtrls,
  ShellApi;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit2: TEdit;
    GroupBox3: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Edit3: TEdit;
    GroupBox4: TGroupBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Edit4: TEdit;
    Label1: TLabel;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure TMKeyboardStatusBar1LightOff(VK_KEY: Integer);
    procedure TMKeyboardStatusBar1LightOn(VK_KEY: Integer);
    procedure UpdateControlStatus(VK_KEY: Integer);
    procedure Edit1Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
var TMKeyboardStatusBar1: TTMKeyboardStatusBar;

implementation

{$R *.DFM}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.INumLock.Locked := (Sender as TCheckBox).Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.INumLock.Status := (Sender as TCheckBox).Checked;
  UpdateControlStatus(VK_NUMLOCK);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  TMKeyboardStatusBar1.INumLock.Text := (Sender as TEdit).Text;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.ICapsLock.Status := (Sender as TCheckBox).Checked;
  UpdateControlStatus(VK_CAPITAL);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.ICapsLock.Locked := (Sender as TCheckBox).Checked;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  TMKeyboardStatusBar1.ICapsLock.Text := (Sender as TEdit).Text;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.IScrollLock.Locked := (Sender as TCheckBox).Checked;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.IScrollLock.Status := (Sender as TCheckBox).Checked;
  UpdateControlStatus(VK_SCROLL);
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  TMKeyboardStatusBar1.IScrollLock.Text := Edit3.Text;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.IInsert.Locked := (Sender as TCheckBox).Checked;
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
  TMKeyboardStatusBar1.IInsert.Status := (Sender as TCheckBox).Checked;
  UpdateControlStatus(VK_INSERT);
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
  TMKeyboardStatusBar1.IInsert.Text := Edit4.Text;
end;

procedure TForm1.UpdateControlStatus(VK_KEY: Integer);
begin
  case VK_KEY of
    VK_NUMLOCK: CheckBox2.Checked := TMKeyboardStatusBar1.INumLock.Status;
    VK_CAPITAL: CheckBox4.Checked := TMKeyboardStatusBar1.ICapsLock.Status;
    VK_SCROLL: CheckBox6.Checked := TMKeyboardStatusBar1.IScrollLock.Status;
    VK_INSERT: CheckBox8.Checked := TMKeyboardStatusBar1.IInsert.Status;
  end;
end;

procedure TForm1.TMKeyboardStatusBar1LightOff(VK_KEY: Integer);
begin
  UpdateControlStatus(VK_KEY);
end;

procedure TForm1.TMKeyboardStatusBar1LightOn(VK_KEY: Integer);
begin
  UpdateControlStatus(VK_KEY);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TMKeyboardStatusBar1 := TTMKeyboardStatusBar.Create(Form1);
  TMKeyboardStatusBar1.Parent := Form1;

  TMKeyboardStatusBar1.INumLock.Text := Edit1.Text;
  TMKeyboardStatusBar1.ICapsLock.Text := Edit2.Text;
  TMKeyboardStatusBar1.IScrollLock.Text := Edit3.Text;
  TMKeyboardStatusBar1.IInsert.Text := Edit4.Text;
  TMKeyboardStatusBar1.OnLightOn := TMKeyboardStatusBar1LightOn;
  TMKeyboardStatusBar1.OnLightOff := TMKeyboardStatusBar1LightOff;

  UpdateControlStatus(VK_NUMLOCK);
  UpdateControlStatus(VK_CAPITAL);
  UpdateControlStatus(VK_SCROLL);
  UpdateControlStatus(VK_INSERT);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TMKeyboardStatusBar1.Free;
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
    ShellExecute(0, 'open',
      PChar('mailto:MilicT@Yahoo.com'
      + '?subject=TMKeyboardStatusBar Demo')
      , nil, nil, 1 {sw_Normal});
end;

end.

